* PACKAGE   !"  (ٷٺɸ)
*
*"  [HIS] 90/05/19(numaguti)
*"        99/11/12(takepiro) ̾롼 -> io 
*
***********************************************************************
      SUBROUTINE ACLATZ      !"  ǥٺɸη׻ 
     O         ( ALAT  , DLAT  , 
     D           JMAX  , JDIM    )
*
      IMPLICIT NONE
*
*"    ------ ɸʻ -------------------------------------
*
*    [INPUT]
      INTEGER    JMAX, JDIM
*
*    [OUTPUT]
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
*
      INTEGER    JDIMD
      PARAMETER  ( JDIMD=200 )
      REAL * 8   QSINLA( JDIMD )             !" sinʰ١ˡ
      REAL * 8   QGW   ( JDIMD )             !" ٽ 
*
*    [INTERNAL PARAM]
      REAL       ALATD0                      !" JMAX=ΤȤ(degree)
      DATA       ALATD0 / 0.0  /
      NAMELIST  /NMLAT0/ ALATD0
*    
*    [INTERNAL WORK]
      INTEGER    IFPAR, JFPAR, J
      REAL       PI, SUMGW
      INTEGER    IUNIT                       !" ɸֹ
*
      CALL GLIGET( 'MSGUNIT', IUNIT )
*
      IF ( JMAX .GT. JDIMD ) THEN
         CALL MSGDMP( 'E', 'SETLAT', 'WORK AREA OVERFULL' )
         RETURN
      ENDIF
*
*"         < 1. ١ٽŤη׻ >
*
      IF ( JMAX .GE. 2 ) THEN
         CALL GAUSS
     O         ( QSINLA , QGW    ,
     I           JMAX             )
      ELSE
*
         WRITE ( IUNIT, * ) ' CONTROL PARAMETER NMLAT0: '
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMLAT0, END=1090 )
 1090    WRITE  ( JFPAR, NMLAT0 )
         PI = ATAN( 1. )*4.
         QSINLA ( 1 ) = SIN( ALATD0/180.*PI )
         QGW    ( 1 ) = 1.0
      ENDIF
*
      SUMGW=0.0  
      DO 1100 J = 1, JMAX
         ALAT  ( J ) = ASIN ( QSINLA ( J ) )
         DLAT  ( J ) = QGW ( J )
         SUMGW = SUMGW + QGW ( J )
 1100 CONTINUE
*
      WRITE ( IUNIT, * ) ' check SUMGW = ', SUMGW
*
      DO 1200 J = JMAX+1, JDIM
         ALAT  ( J ) = ALAT   ( JMAX  )
         DLAT  ( J ) = DLAT   ( JMAX  )
 1200 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE ACLONZ      !"  ǥٺɸη׻ 
     O         ( ALON  , DLON , 
     D           IMAX  , IDIM   )
*
      IMPLICIT NONE
*
*"    ------ ɸʻ -------------------------------------
*
*    [INPUT]
      INTEGER    IMAX, IDIM
*
*    [OUTPUT]
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٺʬ
*
*    [INTERNAL WORK]
      INTEGER    I
      REAL       PI
*
*"         < 1. ٤η׻ >
*
      PI = ATAN( 1. ) *4.
      DO 1100 I = 1, IDIM
         ALON  ( I ) = REAL( I-1 ) / REAL( IMAX ) * 2. * PI
         DLON  ( I ) = 1. / REAL( IMAX )
 1100 CONTINUE
*
      RETURN
      END
