* TEST PROGRAM DEIGNT " deigen ƥ
***********************************************************************
      PROGRAM DEIGNT
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" 礭
*
      REAL      A  ( MATDMX, MATDMX )        !" 
      REAL      EIGVLR( MATDMX )             !" ͭ
      REAL      EIGVLI( MATDMX )             !" ͭ
      REAL      EIGVCR( MATDMX, MATDMX )     !" ͭ٥ȥ
      REAL      EIGVCI( MATDMX, MATDMX )     !" ͭ٥ȥ
      INTEGER   MATDIM                       !" ׻뼡
*
      INTEGER   IS, J, K , NUMEIG, IERR
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( MATDMX*MATDMX )     !" ΰ
*
      IS=0
  100 CONTINUE
*
*  < 1.  >
*
      CALL RESET( A, MATDMX*MATDMX )
      IF (IS .EQ. 0) THEN
         MATDIM = 3
         A(1,1)=33.0D0
         A(2,1)=-24.0D0
         A(3,1)=-8.0D0
         A(1,2)=16.0D0
         A(2,2)=-10.0D0
         A(3,2)=-4.0D0
         A(1,3)=72.0D0
         A(2,3)=-57.0D0
         A(3,3)=-17.0D0
C
C  VALUE = 1, 2, 3
C  VECTOR = (-15,12,4), (-16,13,4), (-4,3,1)
      ELSE
         MATDIM = 4
         A(1,1)=4.
         A(2,1)=0.
         A(3,1)=5.
         A(4,1)=3.
         A(1,2)=-5.
         A(2,2)=4.
         A(3,2)=-3.
         A(4,2)=0.
         A(1,3)=0.
         A(2,3)=-3.
         A(3,3)= 4.
         A(4,3)=5.
         A(1,4)=3.
         A(2,4)=-5.
         A(3,4)=0.
         A(4,4)=4.
      ENDIF
C  VALUE = 12, 1+5I, 1-5i, 2
C  VECTOR = (1,-1,1,1), (1,-i,-i,-1), (1,i,i,-1), (1,1,-1,1)
*
*"  < 2. ͭͷ׻ >
*
      CALL LEIGEN
     M        ( A      , 
     O          EIGVLR , EIGVLI , 
     O          EIGVCR , EIGVCI , 
     O          IERR   , 
     I          MATDIM , .TRUE. , MATDIM )
c$$$      CALL LSLFRQ
c$$$     M           (  EIGVLR , EIGVLI ,
c$$$     M              EIGVCR , EIGVCI ,
c$$$     O              NUMEIG ,
c$$$     I              MATDIM , MATDIM )
      NUMEIG = MATDIM
*
*"  < 3.  >
*
      WRITE ( 6, * )
      WRITE ( 6, * )' CASE ', IS+1 
      WRITE ( 6, * )
      WRITE ( 6, * ) ' Eigen values'
      DO 3110 J=1, NUMEIG
         WRITE ( 6, * ) EIGVLR(J), EIGVLI(J)
 3110 CONTINUE 
      WRITE ( 6, * )
      WRITE ( 6, * ) ' Eigen vectors'
      DO 3100 K = 1, NUMEIG
         WRITE ( 6, * ) ' K = ', K
         DO 3100 J = 1, MATDIM
            WRITE ( 6, * ) EIGVCR(J,K), EIGVCI(J,K)
 3100 CONTINUE 
*
*"  < 4. ĩ ?? > 
*
C      CALL CLCOUT                      !" CPUֽ
      IF (IS .NE. 1) THEN
       IS=IS+1
       GO TO 100
      ENDIF
*
      STOP
      END
**********************************************************************
* PACKAGE LEIGEN  !" ϳ ͭͲ
*
*"  [HIS] 99/12/01(takepiro) SSL2 
*
**********************************************************************
      SUBROUTINE LEIGEN
     M            ( AMAT   , 
     O              EIGVLR , EIGVLI ,
     O              EIGVCR , EIGVCI ,
     O              IERR   , 
     I              MATDIM , OEIVEC , NVEC  )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" 礭
*
*   [MODIFY] 
      REAL      AMAT  ( MATDMX, MATDMX )     !" 
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" ͭͼ¿
      REAL      EIGVLI( MATDMX )             !" ͭ͵
      REAL      EIGVCR( MATDMX, * )          !" ͭ٥ȥ¿
      REAL      EIGVCI( MATDMX, * )          !" ͭ٥ȥ
      INTEGER   IERR                         !" ֥롼󥨥顼
*
*   [INPUT] 
      INTEGER   MATDIM                       !" ׻뼡
      LOGICAL   OEIVEC                       !" ͭؿ׻å
      INTEGER   NVEC                         !" ͭؿ׻
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/  Z
*
      REAL      Z     ( MATDMX, MATDMX )     !" ͭ٥ȥ
      REAL      WORK  ( MATDMX )             !" ΰ
*
      INTEGER   MODE                         !" ʿղå
      PARAMETER ( MODE = 0 )                 !" ʿղ
*
      CHARACTER HERR*8                       !" 顼ֹʸѿ
      INTEGER   NERR                         !" ʸĹ
      INTEGER   LENC                         !" ʸĹ֤ؿ
*
      SAVE      
*
*"  < 1. ͭͷ׻ >
*
C      CALL CLCSTR( 'EIG1' )
*
#ifdef AUTO_DBL
      CALL DEIG1
#else
      CALL EIG1
#endif
     M     (  AMAT   , 
     O        MATDMX , MATDIM , MODE  , 
     O        EIGVLR , EIGVLI , 
     O        Z      , 
     W        WORK   , 
     O        IERR                     )
*
      IF ( IERR .NE. 0 ) THEN
         WRITE( HERR , '(I5)' ) IERR
         CALL CLADJ( HERR )
         NERR = LENC( HERR )
         CALL MSGDMP( 'W', 'LEIGEN', 
     &         'IERR = '//HERR(1:NERR)//' : EIGENVALUES NOT CORRECT ' )
      ENDIF
*
C      CALL CLCEND( 'EIG1' )
*
*"  < 2. ͭ٥ȥ¤ؤ > 
*
C      CALL CLCSTR( 'EIGSRT' )
*
c$$$      CALL  EIGVSR      !" ͭ٥ȥ¤Ѥ
c$$$     O      (  EIGVCR , EIGVCI , 
c$$$     I         EIGVLI , 
c$$$     I         Z      , 
c$$$     I         MATDIM            )
*
      CALL EIGSRT
     M      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI ,
     I         Z      , 
     I         MATDIM , OEIVEC , NVEC  )
*
C      CALL CLCEND( 'EIGSRT' )
*
*"  < 5. λ > 
*
      RETURN
      END
************************************************************************
      SUBROUTINE EIGSRT      !" ͭ͸ͭ٥ȥ¤Ѥ
     M      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI , 
     I         Z      , 
     I         MATDIM , OEIVEC , NVEC  )
*
      IMPLICIT NONE
*
*   [PARA]
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" 礭
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" ͭͼ¿
      REAL      EIGVLI( MATDMX )             !" ͭ͵
      REAL      EIGVCR( MATDMX, * )          !" ͭ٥ȥ¿
      REAL      EIGVCI( MATDMX, * )          !" ͭ٥ȥ
*
*   [INPUT]
      REAL      Z     ( MATDMX, MATDMX )     !" ͭ٥ȥ
*
      INTEGER   MATDIM                       !" ׻뼡
      LOGICAL   OEIVEC                       !" ͭؿ׻å
      INTEGER   NVEC                         !" ͭؿ׻
*
*   [INTERNAL WORK]
      INTEGER   J, K
      INTEGER   INDX  ( MATDMX )             !" ֳǼ
      REAL      WORKR  ( MATDMX )            !" ͭ촹
      REAL      WORKI  ( MATDMX )            !" ͭ촹
*
*
*"  < 1. ͭͤΥ >
*
      CALL INDEXX                                   !" ͭͼ¿ξ
     I       ( MATDIM , EIGVLR ,
     O         INDX              )
*
      CALL COPY( WORKR, EIGVLR, MATDIM )            !" ͭͼ¿
      CALL COPY( WORKI, EIGVLI, MATDIM )            !" ͭ͵
*
      DO 1100 K = 1, MATDIM                         !" ͭͼ¿礭
         EIGVLR( K ) = WORKR( INDX( MATDIM-K+1 ) )
         EIGVLI( K ) = WORKI( INDX( MATDIM-K+1 ) )
 1100 CONTINUE
*
      IF ( OEIVEC )THEN                 
         DO 2000 K = 1, NVEC                        !" ͭͼ¿礭
            IF ( EIGVLI(K) .EQ. 0.0 ) THEN
               DO 2100 J = 1, MATDIM
                  EIGVCR( J,K ) = Z( J,INDX(MATDIM-K+1)  )
                  EIGVCI( J,K ) = 0.
 2100          CONTINUE
*
            ELSE 
               IF (   ( WORKR( INDX(MATDIM-K+1) ) 
     &                    .EQ. WORKR( INDX(MATDIM-K+1)+1 ) )
     &               .AND.
     &                 ( WORKI( INDX(MATDIM-K+1) ) 
     &                    .EQ. -WORKI( INDX(MATDIM-K+1)+1 ) )  )THEN
                  DO 2200 J = 1, MATDIM
                     EIGVCR( J,K ) =  Z( J,INDX(MATDIM-K+1) ) 
                     EIGVCI( J,K ) =  Z( J,INDX(MATDIM-K+1)+1 )
 2200             CONTINUE
*
               ELSE
                  DO 2300 J = 1, MATDIM
                     EIGVCR(J,K) =    Z( J,INDX(MATDIM-K+1)-1 )
                     EIGVCI(J,K) =  - Z( J,INDX(MATDIM-K+1) )
 2300             CONTINUE
               ENDIF
            ENDIF
 2000    CONTINUE 
      ENDIF
*
      RETURN
      END
